# SoMaterial Class Reference
[Nodes]

`#include <Inventor/nodes/SoMaterial.h>`

Inheritance diagram for SoMaterial:

List of all members.

## Detailed Description

The SoMaterial class is a node type for setting up material values for scene geometry.

After traversing an SoMaterial node, subsequent shape nodes with geometry in the scene graph will use values from the material "pool" of the traversal state set up from nodes of this type.

Note that values from a material node will replace the previous values from the traversal state, they will not accumulate.

See also the information on the OpenGL color model, presented in the chapter "Colors and Coloring" (chapter 2.13 in the OpenGL 1.4 specification).

Note that nodes imported as part of a VRML V1.0 file has a special case, where the fields SoMaterial::ambientColor, SoMaterial::diffuseColor and SoMaterial::specularColor contains zero values, and SoMaterial::emissiveColor contains one or more values. The values in SoMaterial::emissiveColor should then be treated as precalculated lighting, and the other fields should be ignored.

You can detect this case by checking the values of the material elements when the scene graph is traversed using an SoCallbackAction. SoDiffuseColorElement, SoAmbientColorElement, and SoSpecularColorElement will contain one value with a completely black color (0.0f, 0.0f, 0.0f), SoShininessElement will contain one value of 0.0f, and SoEmissiveColorElement will contain one or more values. It is done like this to make rendering work correctly on systems that do not test for this specific case.

You should only check for this case when you're traversing a VRML V1.0 file scene graph, of course. See SoNode::getNodeType() for information about how nodes can be tested for whether or not they have been imported or otherwise set up as of VRML1 type versus Inventor type.

When the scene graph is rendered using an SoGLRenderAction, the elements will be set differently to optimize rendering. The SoDiffuseColorElement will be set to the values in SoMaterial::emissiveColor, and the light model will be set to SoLightModel::BASE_COLOR.

The SoMaterial::transparency values will always be treated normally.

Here is a very simple usage example:

      #Inventor V2.1 ascii

      Separator {
         Coordinate3 {
            point [ 0 0 0, 1 0 0, 1 1 0 ]
         }

         Material {
            diffuseColor [ 1 0 0, 1 1 0, 0 0 1 ]
         }

         MaterialBinding {
            value PER_VERTEX
         }

         IndexedFaceSet {
            coordIndex [ 0, 1, 2, -1 ]
         }
      }

See also:
  SoMaterialBinding, SoBaseColor, SoPackedColor

## Public Member Functions

| SoMaterial (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFColor | ambientColor
SoMFColor | diffuseColor
SoMFColor | specularColor
SoMFColor | emissiveColor
SoMFFloat | shininess
SoMFFloat | transparency

## Protected Member Functions

virtual | ~SoMaterial ()
virtual void | notify (SoNotList *list)

## Constructor & Destructor Documentation

SoMaterial::SoMaterial | ( | void |  | ) |

| Constructor.

SoMaterial::~SoMaterial | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoMaterial::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoMaterial::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoMaterial::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoMaterial::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoMaterial::notify | ( | SoNotList * | list | ) | `[protected, virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode.

## Member Data Documentation

SoMFColor SoMaterial::ambientColor

Ambient material part color values. Will by default contain a single color value of [0.2, 0.2, 0.2] (ie dark gray).

The ambient part of the material is not influenced by any lightsources, and should be thought of conceptually as the constant, but small contribution of light to a scene "seeping in" from everywhere.

(Think of the ambient contribution in the context that there's always photons fizzing around everywhere -- even in a black, lightsource-less room, for instance).

See also:
  SoEnvironment::ambientIntensity

SoMFColor SoMaterial::diffuseColor

| Diffuse material part color values. This field is by default initialized to contain a single color value of [0.8, 0.8, 0.8] (light gray). The diffuse part is combined with the light emitted from the scene's light sources.

SoMFColor SoMaterial::specularColor

| Specular material part color values. Defaults to a single color value of [0, 0, 0] (black).

SoMFColor SoMaterial::emissiveColor

| The color of the light "emitted" by the subsequent geometry, independent of lighting / shading. Defaults to contain a single color value of [0, 0, 0] (black, ie no contribution).

SoMFFloat SoMaterial::shininess

| Shininess values. Decides how the light from light sources are distributed across the geometry surfaces. Valid range is from 0.0 (which gives a dim appearance), to 1.0 (glossy-looking surfaces). Defaults to contain a single value of 0.2.

SoMFFloat SoMaterial::transparency

| Transparency values. Valid range is from 0.0 (completely opaque, which is the default) to 1.0 (completely transparent, i.e. invisible). Defaults to contain a single value of 0.0.

The documentation for this class was generated from the following files:

- SoMaterial.h
- SoMaterial.cpp